Unit IIS7R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTII10_p;

procedure IIS7R(var X :Array of Real; NX :Integer;
                var Y :Array of Real; NY :Integer; LX :Integer;
                LY :Integer; var C :Array of Real; XL :Real; YL :Real;
                var FL :Real; var IERR :Integer);

implementation

procedure IIS7R(var X :Array of Real; NX :Integer;
                var Y :Array of Real; NY :Integer; LX :Integer;
                LY :Integer; var C :Array of Real; XL :Real; YL :Real;
                var FL :Real; var IERR :Integer);
var
II,I,NI :Integer;
D,XLM,YLM :Real;
const
ZERO :Real = 0.0;
I4P1 :Integer = 5;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11;
begin
IERR := 0;
if ( NX < 2 ) 
 then goto _4;
if ( NY < 2 ) 
 then goto _5;
NI := NX-1;
for I:=1 to NI do
 begin
  D := X[I+0]-X[I-1];
  if ( D <= ZERO ) 
   then goto _6;
_1:
 end;
NI := NY-1;
for I:=1 to NI do
 begin
  D := Y[I+0]-Y[I-1];
  if ( D <= ZERO ) 
   then goto _7;
_2:
 end;
if ( LX < 1 ) or ( LX >= NX ) 
 then goto _8;
if ( LY < 1 ) or ( LY >= NY ) 
 then goto _9;
if ( XL < X[LX-1] ) or ( XL > X[LX+0] ) 
 then IERR := 1;
if ( IERR <> 0 ) 
 then UTII10(IERR,7);
if ( YL < Y[LY-1] ) or ( YL > Y[LY+0] ) 
 then IERR := 2;
if ( IERR <> 0 ) 
 then UTII10(IERR,7);
XLM := XL-X[LX-1];
YLM := YL-Y[LY-1];
FL := ZERO;
for II:=1 to 4 do
 begin
  I := I4P1-II;
  FL := FL+(C[(I-1)+0]+YLM*(C[(I-1)+4]+YLM*(C[(I-1)+8]+C[(I-1)+12]*YLM)));
  if ( I <> 1 ) 
   then FL := FL*XLM;
_3:
 end;
goto _11;
_4:
IERR := 65;
goto _10;
_5:
IERR := 66;
goto _10;
_6:
IERR := 67;
goto _10;
_7:
IERR := 68;
goto _10;
_8:
IERR := 69;
goto _10;
_9:
IERR := 70;
_10:
UTII10(IERR,7);
_11:
end;

end.
